/* Copyright (c) 1999 TTK Ciar / Bill Moyer
 * All rights reserved.
 *
 * This code is derived from code developed by TTK Ciar and Bill Moyer.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 *  1. Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer.
 *  2. The name of the author may not be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

 
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

main( ac, av ) int ac; char *av[];
  {  int  f;
     int  i, j, bit;
     char asciistr[17];
     int  idatasectionindex = 0;
     unsigned char foo;

     asciistr[8] = 0;
     printf ("[%s]\n",av[1]);
     f = open ( av[1], O_RDONLY );
     if ( f == -1 ) { printf ("oops!\n"); exit(0); }
     i = 0; j = 0;
     while ( read ( f, &foo, 1 ) ) {
       if ( i % 8 == 0 ) 
         printf ( "%6u %5X : ", j, j );
       asciistr[i] = foo;
       if ( ( (unsigned char)asciistr[i] < ' ' ) ||
            ( (unsigned char)asciistr[i] > 127 )    )
          asciistr[i] = '.';
       printf ("%3x",foo);
       i++; j++;
       if ( i % 8 == 0 ) { i = 0; printf (" |%s\n",asciistr); }
       }
     close ( f );
     printf ("\n");
     }
